/* iscm0 -- a scheme like langage.
 * Copyright (C) UNNO Hideyuki <unno.hideyuki@nifty.com>.
 */
#define ISCM_VERSION "0.0.0 (2008-02-07)"

enum {INT_OBJ, STR_OBJ, ID_OBJ, PAIR_OBJ,
      FUNC, BUILTIN_FUNC};

typedef struct S_OBJ {
  int ty;
  union {
    long ival;
    char* pstr;
    struct S_OBJ* car;
    void* pclosure;
  };
  struct S_OBJ* cdr;
} OBJ;

typedef struct S_EXPS {
  OBJ* pexp;
  struct S_EXPS* next;
} EXPS;

void* mycalloc(int);

void append_exp(OBJ *const);
OBJ* create_pair(OBJ *const);
OBJ* append_to_list(OBJ *const, OBJ *const);
OBJ* nil();
void* create_obj_int(long);
void* create_obj_str(const char *const);
void* create_obj_id(const char *const);

void print_obj(OBJ*);
OBJ* eval(OBJ* exp, void* env);
